/*
Esercizio: QSort3.
Facendo riferimento al programma QSort2, visto il 29/2/2016 (vedi Lucidi relativi), 
si rifrasino le strutture in QSort2, in modo da completare il listing sotto e formare
un programma QSort3 equivalente a QSort2.
*/

#include <stdio.h>
#include <stdlib.h>

int N = 15; // Parametro di programma (non modificabile)
void Scambia(int *x, int *y){
    int scambia = *x;
    *x = *y;
    *y = scambia;
}
void leggiSeq(int Seq[], int *upIndex){
    int i = 0;
    while (i<N && scanf("%d",&Seq[i])==1)i++;
    *upIndex = i-1;
}
void stampaSeq(int Seq[], int upIndex){
    for (int i=0; i<upIndex; i++) printf("%d,",Seq[i]);
    printf("%d\n",Seq[upIndex]);
}
void QuickSort(int Left, int Right, int A[]){// procedura ricorsiva
    int I=Left;  //indici in [Left..Right]
    int J=Right; //indici in [Left..Right]
    int temp=A[(Left+Right)/2];
    while (I<=J) {
        while (A[I]<temp) I++;
        while (A[J]>temp) J--;
        if (I<=J){
            Scambia(&A[I],&A[J]);
			I++; J--;
        }
    }
    if (Left<J) QuickSort(Left,J,A);
    if (I<Right) QuickSort(I,Right,A);
}

int main(void){
    int Seq[N];
    int k;
 	leggiSeq(Seq,&k);    //lettura sequenza
    QuickSort(0,k,Seq);	 //ordinamento
    stampaSeq(Seq,k);	 //stampa sequenza
    return(1);
}

/*
 Applicare a lettura/ordinamento/stampa: 1 6 1 9 1 3;
 */
